//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "FrameRateEmulation_.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "VidGrab"
#pragma link "VidGrab"
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
void __fastcall TForm1::FormCreate(TObject *Sender)
{
   iFreeHandMouseDrawing = 0;                // used for free-hand mouse drawing
   FreeHandMouseDrawingEnabled = false;      // used for free-hand mouse drawing

   cmbVideoDevices->Items->Text = VideoDevices();
   cmbVideoDevices->ItemIndex = VideoGrabber1->VideoDevice;

   Memo1->Lines->Add ("storage: " + VideoGrabber1->StoragePath);

   // VideoGrabber1 is the master component
   VideoGrabber1->MultiplexedRole = mr_MultiplexedMaster;

   // VideoGrabber2 is the slave component
   VideoGrabber2->MultiplexedRole = mr_MultiplexedSlave;

   // this associates VideoGrabber2 to VideoGrabber1
   VideoGrabber1->AssociateMultiplexedSlave (0, VideoGrabber2->UniqueID);

   VideoGrabber2->TextOverlay_Enabled = true;
   VideoGrabber2->FrameRate  = 15;

}
//---------------------------------------------------------------------------

void __fastcall TForm1::VideoGrabber1VideoDeviceSelected(TObject *Sender)
{
   cmbVideoDevices->Items->Text = VideoDevices();
   cmbVideoDevices->ItemIndex = VideoGrabber1->VideoDevice;

   cmbAnalogVideoStandards->Items->Text = VideoGrabber1->AnalogVideoStandards;
   cmbAnalogVideoStandards->ItemIndex = VideoGrabber1->AnalogVideoStandard;
   cmbAnalogVideoStandards->Enabled = VideoGrabber1->IsAnalogVideoDecoderAvailable;

   cmbVideoInputs->Items->Text = VideoGrabber1->VideoInputs;
   cmbVideoInputs->ItemIndex = VideoGrabber1->VideoInput;

   cmbVideoSizes->Items->Text = VideoGrabber1->VideoSizes;
   cmbVideoSizes->ItemIndex = VideoGrabber1->VideoSize;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::btnStartClick(TObject *Sender)
{
   VideoGrabber1->StartPreview();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::btnPauseClick(TObject *Sender)
{
   VideoGrabber1->PausePreview();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::btnResumeClick(TObject *Sender)
{
   VideoGrabber1->ResumePreview();

}
//---------------------------------------------------------------------------

void __fastcall TForm1::btnStopClick(TObject *Sender)
{
   VideoGrabber1->StopPreview();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::cmbVideoDevicesChange(TObject *Sender)
{
   VideoGrabber1->VideoDevice = cmbVideoDevices->ItemIndex;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::cmbVideoSizesChange(TObject *Sender)
{
   VideoGrabber1->VideoSize = cmbVideoSizes->ItemIndex;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::cmbVideoInputsChange(TObject *Sender)
{
   VideoGrabber1->VideoInput = cmbVideoInputs->ItemIndex;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::cmbAnalogVideoStandardsChange(TObject *Sender)
{
   VideoGrabber1->AnalogVideoStandard = cmbAnalogVideoStandards->ItemIndex;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::chkTextOverlayClick(TObject *Sender)
{
   VideoGrabber2->TextOverlay_Enabled = chkTextOverlay->Checked;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::btnEraseDrawingClick(TObject *Sender)
{
   iFreeHandMouseDrawing = 0; 
}
//---------------------------------------------------------------------------

void __fastcall TForm1::VideoGrabber2FrameOverlayUsingDC(TObject *Sender,
      HDC Dc, DWORD FrameNumber, Int64 FrameTime, int FrameId)
{
   TCanvas *Canvas;
   int i;

   if (iFreeHandMouseDrawing > 0) { // see VideoGrabberMouseMove event below
      Canvas = new TCanvas;
      Canvas->Handle = Dc;
      Canvas->Pen->Color = clRed;
      for (i = 0;  i < iFreeHandMouseDrawing ; i++) {
         if (FreeHandMouseDrawing[i].Right == 0) { // Right is used as boolean to know if (it is a MoveTo or a LineTo
            Canvas->MoveTo (FreeHandMouseDrawing[i].Left, FreeHandMouseDrawing[i].Top);
            Canvas->Pixels[FreeHandMouseDrawing[i].Left][FreeHandMouseDrawing[i].Top] = clRed;
         }
         else {
            Canvas->LineTo (FreeHandMouseDrawing[i].Left, FreeHandMouseDrawing[i].Top);
         }
      }
      Canvas->Free();
   }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::VideoGrabber2MouseDown(TObject *Sender,
      int VideoWindow, TMouseButton Button, TShiftState Shift, int X,
      int Y)
{
   if (VideoWindow != -1) { // if the video is displayed
      if (chkFreeHandEnabled->Checked) {
         FreeHandMouseDrawing[iFreeHandMouseDrawing].Left = X;
         FreeHandMouseDrawing[iFreeHandMouseDrawing].Top = Y;
         FreeHandMouseDrawing[iFreeHandMouseDrawing].Right = 0; // Right is used as boolean to know if (it is a MoveTo or a LineTo
         iFreeHandMouseDrawing ++;
         FreeHandMouseDrawingEnabled = true;
      }
   }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::VideoGrabber2MouseMove(TObject *Sender,
      int VideoWindow, TShiftState Shift, int X, int Y)
{
   if (VideoWindow != -1) { // if the video is displayed
      if (FreeHandMouseDrawingEnabled) { // has been enabled in the MouseDown event above
         if (iFreeHandMouseDrawing < FreeHandMouseMax) {
            FreeHandMouseDrawing[iFreeHandMouseDrawing].Left = X;
            FreeHandMouseDrawing[iFreeHandMouseDrawing].Top = Y;
            FreeHandMouseDrawing[iFreeHandMouseDrawing].Right = 1; // Right is used as boolean to know if (it is a MoveTo or a LineTo
            iFreeHandMouseDrawing ++;
         }
      }
   }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::VideoGrabber2MouseUp(TObject *Sender,
      int VideoWindow, TMouseButton Button, TShiftState Shift, int X,
      int Y)
{
   FreeHandMouseDrawingEnabled = false;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::btnCaptureToImageClick(TObject *Sender)
{
   VideoGrabber2->CaptureFrameTo (fc_TBitmap, "");
}
//---------------------------------------------------------------------------

void __fastcall TForm1::btnCaptureToJPEGClick(TObject *Sender)
{
   VideoGrabber2->CaptureFrameTo (fc_JpegFile, "");
}
//---------------------------------------------------------------------------

void __fastcall TForm1::btnCaptureToBMPClick(TObject *Sender)
{
   VideoGrabber2->CaptureFrameTo (fc_BmpFile, "");
}
//---------------------------------------------------------------------------

void __fastcall TForm1::VideoGrabber2FrameCaptureCompleted(TObject *Sender,
      Pointer FrameBitmap, int BitmapWidth, int BitmapHeight,
      DWORD FrameNumber, Int64 FrameTime, TFrameCaptureDest DestType,
      AnsiString FileName, bool Success, int FrameId)
{
   Graphics::TBitmap *Frame_Bitmap;

   Frame_Bitmap = (Graphics::TBitmap*) FrameBitmap;

   switch (DestType) {
      case fc_BmpFile:
         Memo1->Lines->Add (FileName + " created");
      break;

      case fc_JpegFile:
         Memo1->Lines->Add (FileName + " created");
      break;

      case fc_TBitmap:

      bool AlternateMethod = False; // you can choose one of the 2 methods below (set True to test the 2nd)

      if (! AlternateMethod) { // this code reassign the bitmap handle to the picture (saves CPU)
         Image1->Picture->Bitmap->Handle = Frame_Bitmap->Handle;
         Frame_Bitmap->ReleaseHandle();
      }
      else { // this code makes a copy of the bitmap
         Image1->Picture->Assign (Frame_Bitmap);
      }
      break;
   }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::btnFrameRateClick(TObject *Sender)
{
   VideoGrabber2->FrameRate = StrToFloatDef (edtFrameRate->Text, 15);
   VideoGrabber1->StartPreview();
}
//---------------------------------------------------------------------------

