//---------------------------------------------------------------------------
#ifndef MainFormH
#define MainFormH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "VidGrab.hpp"
#include <ExtCtrls.hpp>
#include <Buttons.hpp>
#include <ComCtrls.hpp>
#include <Dialogs.hpp>
#include <Graphics.hpp>
#include <Menus.hpp>
#include <jpeg.hpp>
//---------------------------------------------------------------------------

const FreeHandMouseMax = 1000;

class TfrmMainForm : public TForm
{
__published:	// IDE-managed Components
        TLabel *Label9;
        TMemo *mmoLog;
        TEdit *edtStoragePath;
        TEdit *edtFrameCount;
        TEdit *edtDVDateTime;
        TGroupBox *grbPlayerControl;
        TSpeedButton *btnPlayerBackwards;
        TSpeedButton *btnPlayerPause;
        TSpeedButton *btnPlayerStop;
        TSpeedButton *btnPlayerStartPlaying;
        TSpeedButton *btnPlayerRewind;
        TSpeedButton *btnPlayerFastForward;
        TTrackBar *tbrPlayerProgress;
        TVideoGrabber *VideoGrabber;
        TMainMenu *MainMenu1;
        TMenuItem *mnuFile;
        TMenuItem *mnuExit;
        TMenuItem *mnuSendDVCommands;
        TMenuItem *mnuDVPlay;
        TMenuItem *mnuDVStop;
        TMenuItem *mnuDVFreeze;
        TMenuItem *mnuDVThaw;
        TMenuItem *mnuDVFF;
        TMenuItem *mnuDVRew;
        TMenuItem *mnuDVRecord;
        TMenuItem *mnuDVRecordfreeze;
        TMenuItem *mnuDVRecordStrobe;
        TMenuItem *mnuDVStepFwd;
        TMenuItem *mnuDVStepRev;
        TMenuItem *mnuDVModeShuttle;
        TMenuItem *mnuDVPlayfastestfwd;
        TMenuItem *mnuDVPlayslowestfwd;
        TMenuItem *mnuDVPlayfastestrev;
        TMenuItem *mnuDVPlayslowestrev;
        TMenuItem *mnuAbout;
        TOpenDialog *dlgOpen;
        TPageControl *pctMain;
        TTabSheet *tbsVideoDevice;
        TTabSheet *tbsAudio;
        TTabSheet *tbsRecording;
        TTabSheet *tbsASFStreaming;
        TTabSheet *tbsPlayer;
        TLabel *Label23;
        TLabel *Label8;
        TLabel *Label40;
        TLabel *Label41;
        TEdit *edtPlayerFastSeekSpeed;
        TEdit *edtPlayerSpeedRatio;
        TUpDown *updPlayerSpeedRatio;
        TUpDown *updPlayerFastSeekSpeed;
        TCheckBox *btnAutoPlay;
        TTabSheet *tbsFrameGrabber;
        TTabSheet *tbsClipReencoding;
        TTabSheet *TabSheet1;
        TMemo *mmoSensitivityGrid;
        TMemo *mmoMotionGrid;
        TTabSheet *tbsFrameOverlay;
        TGroupBox *grbTextOverlay;
        TLabel *Label13;
        TLabel *Label20;
        TLabel *Label22;
        TRadioGroup *rdgTextOverlayAlign;
        TCheckBox *chkTextOverlayEnabled;
        TCheckBox *chkTextOverlayTransparent;
        TMemo *mmoTextOverlayString;
        TEdit *edtTextOverlayTop;
        TEdit *edtTextOverlayLeft;
        TEdit *edtTextOverlayWidth;
        TGroupBox *grbFreeHand;
        TCheckBox *chkFreeHandEnabled;
        TButton *btnFreeHandErase;
        TGroupBox *grbLinesOverlay;
        TCheckBox *chkLinesOverlayEnabled;
        TGroupBox *grbShapeOverlay;
        TShape *shpShapeOverlay;
        TLabel *Label27;
        TEdit *edtShapeOverlayLeft;
        TEdit *edtShapeOverlayTop;
        TEdit *edtShapeOverlayWidth;
        TEdit *edtShapeOverlayHeight;
        TCheckBox *chkShapeOverlayEnabled;
        TRadioGroup *grbColorFiltering;
        TTabSheet *tbsVideoProcessing;
        TTabSheet *tbsDisplay;
        TTabSheet *tbsTVTuner;
        TLabel *Label50;
        TLabel *lblTVTunerAvailable;
        TGroupBox *grbTunerCountryCode;
        TGroupBox *grbCountryCode;
        TEdit *edtCountryCode;
        TButton *btnSetCountryCode;
        TRadioGroup *rdgTunerInputType;
        TGroupBox *grbTVChannel;
        TEdit *edtTVChannel;
        TButton *btnSelect;
        TGroupBox *grbFrequencyOverride;
        TEdit *edtChannelFrequency;
        TButton *btnDeleteFrequencyOverride;
        TButton *chkSetFrequencyOverride;
        TCheckBox *chkEnableFrequencyOverrides;
        TGroupBox *grbTVScan;
        TButton *btnStopScan;
        TButton *btnStartScan;
        TButton *btnResetAllOverrides;
        TMemo *mmoChannelLog;
        TCheckBox *chkPlayerAudioRendering;
        TGroupBox *grbDirectASFStreaming;
        TLabel *Label10;
        TLabel *Label24;
        TEdit *edtNetworkPort;
        TEdit *edtNetworkMaxUsers;
        TGroupBox *grbASFStreamingToWMServer;
        TLabel *Label32;
        TEdit *edtPublishingPoint;
        TLabel *Label42;
        TLabel *Label43;
        TRadioGroup *rgdFrameGrabber;
        TRadioGroup *rgdFrameGrabberFormat;
        TGroupBox *grnFileNames;
        TLabel *Label46;
        TRadioGroup *rdgAutoFileName;
        TEdit *edtAVIAutoFilePrefix;
        TGroupBox *grbOneShot;
        TEdit *edtUseThisFileName;
        TButton *btnOneShotTBitmap;
        TButton *btnOneShotBMPFile;
        TButton *btnOneShotJPEGFile;
        TCheckBox *chkUseThisFileName;
        TGroupBox *grbBurstMode;
        TLabel *Label14;
        TLabel *Label15;
        TButton *btnBurstModeBMPFile;
        TButton *btnBurstModeJPEGFile;
        TEdit *edtBurstCount;
        TEdit *edtBurstInterval;
        TButton *btnBurstModeStop;
        TButton *btnBurstModeTBitmap;
        TGroupBox *grbZoomSize;
        TLabel *Label12;
        TTrackBar *tbrCaptureZoomSize;
        TEdit *edtCaptureZoomSize;
        TButton *btnResetCaptureZoomSize;
        TMemo *mmoFrameCaptureLog;
        TCheckBox *chkRefreshPausedDisplay;
        TSpeedButton *btnSourceVideoClip;
        TEdit *edtSourceVideoClip;
        TEdit *edtDestinationVideoClip;
        TLabel *Label75;
        TLabel *Label45;
        TGroupBox *grbStartStopTime;
        TLabel *Label78;
        TLabel *Label79;
        TLabel *Label77;
        TEdit *edtStartTime;
        TEdit *edtDuration;
        TEdit *edtStopTime;
        TButton *btnDuration;
        TGroupBox *grbReencodingSettings;
        TCheckBox *chkIncludeVideoStream;
        TCheckBox *chkIncludeAudioStream;
        TCheckBox *chkUseCurrentVideoCompressor;
        TCheckBox *chkUseCurrentAudioCompressor;
        TCheckBox *chkUseFrameGrabber;
        TCheckBox *chkWMVOutput;
        TRadioGroup *rdgReencodingMethod;
        TButton *btnStartReencoding;
        TButton *btnStopReencoding;
        TRadioGroup *rdgDVPlaybackSize;
        TLabel *Label47;
        TLabel *lblFrameOverlayRequiresFrameGrabber;
        TRadioGroup *rdgNetworkStreaming;
        TGroupBox *grbASFSettings;
        TLabel *Label39;
        TLabel *Label44;
        TLabel *Label67;
        TLabel *Label68;
        TLabel *Label69;
        TLabel *Label70;
        TLabel *Label71;
        TLabel *Label83;
        TEdit *edtASFVideoWidth;
        TEdit *edtASFVideoHeight;
        TEdit *edtASFVideoBitRate;
        TEdit *edtASFVideoMaxKeyFrameSpacing;
        TEdit *edtASFVideoQuality;
        TEdit *edtASFAudioChannels;
        TComboBox *cmbASFDeinterlaceMode;
        TCheckBox *chkASFFixedFrameRate;
        TGroupBox *grbASFProfiles;
        TLabel *Label34;
        TListBox *lsbProfiles;
        TButton *btnShowProfilesList;
        TEdit *edtProfileIndex;
        TButton *btnViewDirectNetworkStreaming;
        TLabel *Label21;
        TRadioGroup *rdgPreferredVideoSize;
        TGroupBox *grbVideoDeviceDialogs;
        TButton *btnDeviceDialog;
        TButton *btnStreamDialog;
        TButton *btnVideoQualityDialog;
        TButton *btnCameraControlDialog;
        TButton *btnVideoControlDialog;
        TCheckBox *chkStretchPreferredVideoSize;
        TCheckBox *btnAutoRefreshPreview;
        TGroupBox *grbCropping;
        TLabel *Label85;
        TLabel *Label86;
        TLabel *Label87;
        TLabel *Label84;
        TLabel *Label88;
        TCheckBox *chkCroppingEnabled;
        TTrackBar *trkCroppingX;
        TTrackBar *trkCroppingY;
        TEdit *edtCroppingWidth;
        TEdit *edtCroppingHeight;
        TTrackBar *trkCroppingZoom;
        TCheckBox *chkCroppingOutbounds;
        TButton *btnCroppingZoomReset;
        TGroupBox *grbVMR9Adjust;
        TLabel *Label7;
        TLabel *Label28;
        TTrackBar *tbrVMR9Brightness;
        TTrackBar *tbrVMR9Contrast;
        TTrackBar *tbrVMR9Saturation;
        TTrackBar *tbrVMR9Hue;
        TCheckBox *vmr9FixRange;
        TCheckBox *chk2ndVideoWindowActive;
        TGroupBox *grb2ndVideoWindow;
        TCheckBox *chk2ndEmbedded;
        TCheckBox *chk2ndFullScreen;
        TCheckBox *chk2ndStayOnTop;
        TCheckBox *chk2ndUseVideoPort;
        TRadioGroup *rdg2ndDisplayedOn;
        TCheckBox *chk2ndMouseMovesWindow;
        TCheckBox *chk2ndAutoSize;
        TCheckBox *chk2ndKeepAspectRatio;
        TButton *btnEG2ndNewLocation;
        TButton *btnEG2ndNewLocation2;
        TCheckBox *chk1stVideoWindowActive;
        TGroupBox *grbMainVideoWindow;
        TCheckBox *chk1stEmbedded;
        TCheckBox *chk1stFullScreen;
        TCheckBox *chk1stStayOnTop;
        TCheckBox *chk1stUseVideoPort;
        TRadioGroup *rdg1stDisplayedOn;
        TCheckBox *chk1stMouseMovesWindow;
        TCheckBox *chk1stAutoSize;
        TCheckBox *chk1stKeepAspectRatio;
        TButton *btnEG1stNewLocation;
        TButton *btnEG1stNewLocation2;
        TCheckBox *chkChangeCursor;
        TCheckBox *chkBorder;
        TCheckBox *chkTransparency;
        TCheckBox *chkSetLogo;
        TImage *imgLogo;
        TRadioGroup *rdgVideoRenderer;
        TGroupBox *grbVideoSource;
        TComboBox *cboVideoSource;
        TGroupBox *grbPreview;
        TBitBtn *btnStartPreview;
        TButton *btnStopPreview;
        TGroupBox *grbFrameRate;
        TEdit *edtFrameRate;
        TButton *btnFrameRate;
        TLabel *Label38;
        TBitBtn *btnStartRecordingImmediately;
        TBitBtn *btnStartRecordingControlled;
        TButton *btnStopRecording;
        TCheckBox *chkRenderAudioDevice;
        TGroupBox *grbAudioCaptureDevice;
        TLabel *Label26;
        TLabel *Label49;
        TLabel *Label36;
        TLabel *Label81;
        TComboBox *cboAudioDevices;
        TComboBox *cboAudioInputs;
        TTrackBar *tbrAudioInputLevel;
        TTrackBar *tbrAudioInputBalance;
        TCheckBox *chkAudioInputMono;
        TGroupBox *grbAudioRendering;
        TLabel *Label1;
        TLabel *Label17;
        TTrackBar *tbrAudioVolume;
        TTrackBar *tbrAudioBalance;
        TCheckBox *chkMuteAudioRendering;
        TButton *btnRenewRecordingFile;
        TLabel *Label53;
        TLabel *lblMotionDetectorRequiresFrameGrabber;
        TCheckBox *chkMotionDetectionEnabled;
        TCheckBox *chkReduceVideoNoise;
        TButton *btnShowGridDialog;
        TLabel *Label54;
        TCheckBox *chkCompareRed;
        TCheckBox *chkCompareGreen;
        TCheckBox *chkCompareBlue;
        TCheckBox *chk_GreyScale;
        TImage *imgMotionDetected;
        TGroupBox *grbMotionRatio;
        TShape *shpMotionDetected;
        TEdit *edtMotionRatio;
        TGroupBox *grbXYMaxMotion;
        TEdit *edtMaxMotionXY;
        TEdit *edtMaxMotionCoord;
        TGroupBox *grbCellsSensitivity;
        TLabel *Label57;
        TLabel *Label58;
        TLabel *Label59;
        TEdit *edtXCell;
        TUpDown *updXCell;
        TEdit *edtYCell;
        TUpDown *updYCell;
        TEdit *edtCellSensitivity;
        TUpDown *updCellSensitivity;
        TButton *btnSetCellsSensitivity;
        TGroupBox *grbGridSize;
        TLabel *Label55;
        TLabel *Label56;
        TEdit *edtGridColCount;
        TUpDown *updGridColCount;
        TEdit *edtGridRowCount;
        TUpDown *updGridRowCount;
        TButton *btnApplyGridSize;
        TGroupBox *grbGridString;
        TLabel *Label51;
        TLabel *lblGridValid;
        TShape *shpGridValid;
        TEdit *edtGrid;
        TUpDown *updGlobalGridSensitivity;
        TLabel *Label29;
        TGroupBox *grbSoftwareVideoProcessing;
        TLabel *Label31;
        TRadioGroup *rdgVideoRotation;
        TRadioGroup *rdgDeinterlacing;
        TCheckBox *chkFlipVertical;
        TCheckBox *chkFlipHorizontal;
        TCheckBox *chkGreyScale;
        TCheckBox *chkInvertColors;
        TButton *btnResetAll;
        TTrackBar *tbrBrightness;
        TTrackBar *tbrConstrast;
        TTrackBar *tbrSaturation;
        TTrackBar *tbrHue;
        TCheckBox *chkPreserveNativeFormat;
        TButton *btnNativeFormat;
        TCheckBox *chkAVISaveToThisFile;
        TEdit *edtRecordingFileName;
        TCheckBox *chkOpenDML;
        TCheckBox *chkPreallocFile;
        TEdit *edtPreallocSize;
        TLabel *Label11;
        TButton *btnCreatePreallocFileNow;
        TRadioGroup *rdgRecordingMethod;
        TGroupBox *grbAVIPauseResume;
        TCheckBox *chkRecordingCanPause;
        TButton *btnPauseRecording;
        TButton *btnResumeRecording;
        TLabel *Label37;
        TLabel *Label3;
        TGroupBox *grbCompression;
        TLabel *Label6;
        TLabel *Label16;
        TComboBox *cboVideoCompressors;
        TButton *btnVideoCompressorSettings;
        TComboBox *cboAudioCompressors;
        TButton *btnAudioCompressorSettings;
        TRadioGroup *rdgCompressMode;
        TRadioGroup *rdgCompressType;
        TCheckBox *chkAudioRecording;
        TLabel *Label5;
        TComboBox *cboAudioFormats;
        TSpeedButton *btnPlayerOpenFile;
        TEdit *edtPlayerClip;
        TButton *btnGetClipDuration;
        TButton *btnOpenClip;
        TButton *btnPlayerCloseClip;
        TSpeedButton *btnOpenLastClipRecorded;
        TSpeedButton *btnOpenLastClipPlayed;
        TSpeedButton *btnPlayerOpenStreamingURL;
        TGroupBox *grbBitmapOverlay;
        TImage *imgBitmapOverlay;
        TLabel *Label25;
        TLabel *Label48;
        TLabel *Label82;
        TSpeedButton *btnLoadImageOverlayFromFile;
        TCheckBox *chkBitmapOverlayEnabled;
        TTrackBar *tbrBitmapOverlaySize;
        TButton *btnBitmapOverlayResetSize;
        TEdit *edtBitmapOverlaySize;
        TEdit *edtBitmapOvlerlayLeft;
        TEdit *edtBitmapOvlerlayTop;
        TEdit *edtBitmapOverlayAlphaBlend;
        TUpDown *updBitmapOverlayAlphaBend;
        TCheckBox *chkBitmapOverlayAlphaBlend;
        TCheckBox *chkBitmapOverlayTransparent;
        TCheckBox *chkBitmapOverlayUseTransparentColor;
        TComboBox *cmbBitmapOverlayTransparentColor;
        TGroupBox *grbVsVideoCaptureDevice;
        TLabel *Label2;
        TLabel *Label4;
        TLabel *Label18;
        TLabel *Label19;
        TComboBox *cboVideoInputs;
        TComboBox *cboVideoSizes;
        TComboBox *cboVideoSubtypes;
        TComboBox *cboAnalogVideoStandard;
        TComboBox *cboVideoDevices;
        TCheckBox *chkReduceDVFrameRate;
        TGroupBox *GroupBox1;
        TCheckBox *chkMultiplexedAutoSwitch;
        TCheckBox *chkMultiplexedInputEmulation;
        TGroupBox *grbVsFileOrUrl;
        TSpeedButton *btnSelectFileOrUrl;
        TEdit *edtVideoSourceFileOrUrl;
        TGroupBox *grbVsScreenRecording;
        TCheckBox *chkScreenRecordingWithCursor;
        TCheckBox *chkTriggered;
        TButton *btnTriggerNow;
        void __fastcall FormCreate(TObject *Sender);
        void __fastcall FormShow(TObject *Sender);
        void __fastcall cboVideoDevicesChange(TObject *Sender);
        void __fastcall btnStartPreviewClick(TObject *Sender);
        void __fastcall btnStopPreviewClick(TObject *Sender);
        void __fastcall btnPausePreviewClick(TObject *Sender);
        void __fastcall btnResumePreviewClick(TObject *Sender);
        void __fastcall btnAutoRefreshPreviewClick(TObject *Sender);
        void __fastcall cboVideoInputsChange(TObject *Sender);
        void __fastcall cboVideoSizesChange(TObject *Sender);
        void __fastcall cboAnalogVideoStandardChange(TObject *Sender);
        void __fastcall cboVideoSubtypesChange(TObject *Sender);
        void __fastcall btnDeviceDialogClick(TObject *Sender);
        void __fastcall btnStreamDialogClick(TObject *Sender);
        void __fastcall btnCameraControlDialogClick(TObject *Sender);
        void __fastcall btnVideoQualityDialogClick(TObject *Sender);
        void __fastcall btnVideoControlDialogClick(TObject *Sender);
        void __fastcall btnFrameRateClick(TObject *Sender);
        void __fastcall chkReduceDVFrameRateClick(TObject *Sender);
        void __fastcall VideoGrabberVideoDeviceSelected(TObject *Sender);
        void __fastcall VideoGrabberPreviewStarted(TObject *Sender);
        void __fastcall cboAudioInputsChange(TObject *Sender);
        void __fastcall cboAudioDevicesChange(TObject *Sender);
        void __fastcall tbrAudioInputLevelChange(TObject *Sender);
        void __fastcall cboAudioFormatsChange(TObject *Sender);
        void __fastcall VideoGrabberAudioDeviceSelected(TObject *Sender);
        void __fastcall chkPlayerAudioRenderingClick(TObject *Sender);
        void __fastcall btnStopRecordingClick(TObject *Sender);
        void __fastcall rdgRecordingMethodClick(TObject *Sender);
        void __fastcall chkRecordingCanPauseClick(TObject *Sender);
        void __fastcall btnPauseRecordingClick(TObject *Sender);
        void __fastcall btnResumeRecordingClick(TObject *Sender);
        void __fastcall chkOpenDMLClick(TObject *Sender);
        void __fastcall chkPreallocFileClick(TObject *Sender);
        void __fastcall btnCreatePreallocFileNowClick(TObject *Sender);
        void __fastcall edtPreallocSizeChange(TObject *Sender);
        void __fastcall cboVideoCompressorsChange(TObject *Sender);
        void __fastcall cboAudioCompressorsChange(TObject *Sender);
        void __fastcall btnVideoCompressorSettingsClick(TObject *Sender);
        void __fastcall btnAudioCompressorSettingsClick(TObject *Sender);
        void __fastcall rdgCompressModeClick(TObject *Sender);
        void __fastcall rdgCompressTypeClick(TObject *Sender);
        void __fastcall rgdFrameGrabberClick(TObject *Sender);
        void __fastcall rgdFrameGrabberFormatClick(TObject *Sender);
        void __fastcall rdgAutoFileNameClick(TObject *Sender);
        void __fastcall edtAVIAutoFilePrefixChange(TObject *Sender);
        void __fastcall btnPlayerCloseFileClick(TObject *Sender);
        void __fastcall updPlayerSpeedRatioClick(TObject *Sender,
          TUDBtnType Button);
        void __fastcall updPlayerFastSeekSpeedClick(TObject *Sender,
          TUDBtnType Button);
        void __fastcall btnPlayerOpenStreamingURLClick(TObject *Sender);
        void __fastcall btnPlayerOpenFileClick(TObject *Sender);
        void __fastcall btnPlayerPauseClick(TObject *Sender);
        void __fastcall btnPlayerStopClick(TObject *Sender);
        void __fastcall btnPlayerStartPlayingClick(TObject *Sender);
        void __fastcall btnPlayerBackwardsClick(TObject *Sender);
        void __fastcall btnPlayerRewindClick(TObject *Sender);
        void __fastcall btnPlayerFastForwardClick(TObject *Sender);
        void __fastcall btnAutoPlayClick(TObject *Sender);
        void __fastcall VideoGrabberPlayerBufferingData(TObject *Sender,
          bool StartingToBuffer);
        void __fastcall VideoGrabberPlayerEndOfStream(TObject *Sender);
        void __fastcall rdgPreferredVideoSizeClick(TObject *Sender);
        void __fastcall chkRenderAudioDeviceClick(TObject *Sender);
        void __fastcall rdgNetworkStreamingClick(TObject *Sender);
        void __fastcall edtPublishingPointChange(TObject *Sender);
        void __fastcall edtNetworkPortChange(TObject *Sender);
        void __fastcall edtNetworkMaxUsersChange(TObject *Sender);
        void __fastcall btnShowProfilesListClick(TObject *Sender);
        void __fastcall lsbProfilesClick(TObject *Sender);
        void __fastcall edtProfileIndexChange(TObject *Sender);
        void __fastcall btnOneShotTBitmapClick(TObject *Sender);
        void __fastcall btnOneShotBMPFileClick(TObject *Sender);
        void __fastcall btnOneShotJPEGFileClick(TObject *Sender);
        void __fastcall chkUseThisFileNameClick(TObject *Sender);
        void __fastcall btnBurstModeTBitmapClick(TObject *Sender);
        void __fastcall btnBurstModeBMPFileClick(TObject *Sender);
        void __fastcall btnBurstModeJPEGFileClick(TObject *Sender);
        void __fastcall btnBurstModeStopClick(TObject *Sender);
        void __fastcall edtBurstCountChange(TObject *Sender);
        void __fastcall edtBurstIntervalChange(TObject *Sender);
        void __fastcall tbrCaptureZoomSizeChange(TObject *Sender);
        void __fastcall btnResetCaptureZoomSizeClick(TObject *Sender);
        void __fastcall rdgTunerInputTypeClick(TObject *Sender);
        void __fastcall btnSetCountryCodeClick(TObject *Sender);
        void __fastcall btnSelectClick(TObject *Sender);
        void __fastcall chkSetFrequencyOverrideClick(TObject *Sender);
        void __fastcall btnDeleteFrequencyOverrideClick(TObject *Sender);
        void __fastcall chkEnableFrequencyOverridesClick(TObject *Sender);
        void __fastcall btnStartScanClick(TObject *Sender);
        void __fastcall btnStopScanClick(TObject *Sender);
        void __fastcall btnResetAllOverridesClick(TObject *Sender);
        void __fastcall VideoGrabberTVChannelScanStarted(TObject *Sender,
          int MinChannel, int MaxChannel);
        void __fastcall VideoGrabberTVChannelScanCompleted(
          TObject *Sender);
        void __fastcall chkTextOverlayEnabledClick(TObject *Sender);
        void __fastcall chkTextOverlayTransparentClick(TObject *Sender);
        void __fastcall rdgTextOverlayAlignClick(TObject *Sender);
        void __fastcall mmoTextOverlayStringChange(TObject *Sender);
        void __fastcall edtTextOverlayLeftChange(TObject *Sender);
        void __fastcall edtTextOverlayTopChange(TObject *Sender);
        void __fastcall edtTextOverlayWidthChange(TObject *Sender);
        void __fastcall btnFreeHandEraseClick(TObject *Sender);
        void __fastcall tbrBitmapOverlaySizeChange(TObject *Sender);
        void __fastcall btnBitmapOverlayResetSizeClick(TObject *Sender);
        void __fastcall chkShapeOverlayEnabledClick(TObject *Sender);
        void __fastcall edtShapeOverlayLeftChange(TObject *Sender);
        void __fastcall edtShapeOverlayTopChange(TObject *Sender);
        void __fastcall edtShapeOverlayWidthChange(TObject *Sender);
        void __fastcall edtShapeOverlayHeightChange(TObject *Sender);
        void __fastcall VideoGrabberMouseMove(TObject *Sender,
          int VideoWindow, TShiftState Shift, int X, int Y);
        void __fastcall VideoGrabberMouseDown(TObject *Sender,
          int VideoWindow, TMouseButton Button, TShiftState Shift, int X,
          int Y);
        void __fastcall VideoGrabberMouseUp(TObject *Sender,
          int VideoWindow, TMouseButton Button, TShiftState Shift, int X,
          int Y);
        void __fastcall VideoGrabberResizeVideo(TObject *Sender,
          int SourceWidth, int SourceHeight);
        void __fastcall rdgVideoRotationClick(TObject *Sender);
        void __fastcall rdgDeinterlacingClick(TObject *Sender);
        void __fastcall tbrBrightnessChange(TObject *Sender);
        void __fastcall tbrConstrastChange(TObject *Sender);
        void __fastcall tbrSaturationChange(TObject *Sender);
        void __fastcall tbrHueChange(TObject *Sender);
        void __fastcall btnResetAllClick(TObject *Sender);
        void __fastcall chkFlipVerticalClick(TObject *Sender);
        void __fastcall chkFlipHorizontalClick(TObject *Sender);
        void __fastcall chkGreyScaleClick(TObject *Sender);
        void __fastcall chkInvertColorsClick(TObject *Sender);
        void __fastcall chkBorderClick(TObject *Sender);
        void __fastcall chkTransparencyClick(TObject *Sender);
        void __fastcall rdgVideoRendererClick(TObject *Sender);
        void __fastcall chk1stVideoWindowActiveClick(TObject *Sender);
        void __fastcall chk1stEmbeddedClick(TObject *Sender);
        void __fastcall chk1stAutoSizeClick(TObject *Sender);
        void __fastcall chk1stKeepAspectRatioClick(TObject *Sender);
        void __fastcall chk1stFullScreenClick(TObject *Sender);
        void __fastcall chk1stStayOnTopClick(TObject *Sender);
        void __fastcall chk1stUseVideoPortClick(TObject *Sender);
        void __fastcall rdg1stDisplayedOnClick(TObject *Sender);
        void __fastcall btnEG1stNewLocationClick(TObject *Sender);
        void __fastcall btnEG1stNewLocation2Click(TObject *Sender);
        void __fastcall chk1stMouseMovesWindowClick(TObject *Sender);
        void __fastcall chk2ndVideoWindowActiveClick(TObject *Sender);
        void __fastcall chk2ndEmbeddedClick(TObject *Sender);
        void __fastcall chk2ndFullScreenClick(TObject *Sender);
        void __fastcall chk2ndAutoSizeClick(TObject *Sender);
        void __fastcall chk2ndKeepAspectRatioClick(TObject *Sender);
        void __fastcall chk2ndStayOnTopClick(TObject *Sender);
        void __fastcall chk2ndUseVideoPortClick(TObject *Sender);
        void __fastcall chk2ndMouseMovesWindowClick(TObject *Sender);
        void __fastcall rdg2ndDisplayedOnClick(TObject *Sender);
        void __fastcall btnEG2ndNewLocationClick(TObject *Sender);
        void __fastcall btnEG2ndNewLocation2Click(TObject *Sender);
        void __fastcall VideoGrabberColorKeyChange(TObject *Sender,
          TColor ColorKey);
        void __fastcall edtStoragePathChange(TObject *Sender);
        void __fastcall VideoGrabberLog(TObject *Sender, TLogType LogType,
          AnsiString Severity, AnsiString InfoMsg);
        void __fastcall VideoGrabberDVCommandCompleted(TObject *Sender,
          int NewStateValue, AnsiString NewStateLabel);
        void __fastcall mnuAboutClick(TObject *Sender);
        void __fastcall VideoGrabberResize(TObject *Sender);
        void __fastcall VideoGrabberDeviceLost(TObject *Sender);
        void __fastcall VideoGrabberDiskFull(TObject *Sender);
        void __fastcall VideoGrabberDeviceArrivalOrRemoval(TObject *Sender,
          bool IsDeviceArrival, bool IsVideoDevice, AnsiString DeviceName,
          int DeviceIndex);
        void __fastcall mnuExitClick(TObject *Sender);
        void __fastcall chkCompareRedClick(TObject *Sender);
        void __fastcall chkCompareGreenClick(TObject *Sender);
        void __fastcall chkCompareBlueClick(TObject *Sender);
        void __fastcall chk_GreyScaleClick(TObject *Sender);
        void __fastcall chkReduceVideoNoiseClick(TObject *Sender);
        void __fastcall edtGridChange(TObject *Sender);
        void __fastcall updGlobalGridSensitivityClick(TObject *Sender,
          TUDBtnType Button);
        void __fastcall btnApplyGridSizeClick(TObject *Sender);
        void __fastcall btnSetCellsSensitivityClick(TObject *Sender);
        void __fastcall btnShowGridDialogClick(TObject *Sender);
        void __fastcall chkMotionDetectionEnabledClick(TObject *Sender);
        void __fastcall tbrAudioInputBalanceChange(TObject *Sender);
        void __fastcall chkAudioInputMonoClick(TObject *Sender);
        void __fastcall VideoGrabberReinitializing(TObject *Sender);
        void __fastcall VideoGrabberCreatePreallocFileStarted(
          TObject *Sender, AnsiString FileName);
        void __fastcall VideoGrabberCreatePreallocFileCompleted(
          TObject *Sender, AnsiString FileName, bool Success);
        void __fastcall VideoGrabberCopyPreallocDataStarted(
          TObject *Sender, AnsiString SourceFile, AnsiString DestFile);
        void __fastcall VideoGrabberCopyPreallocDataCompleted(
          TObject *Sender, AnsiString SourceFile, AnsiString DestFile,
          bool Success);
        void __fastcall edtASFVideoWidthChange(TObject *Sender);
        void __fastcall edtASFVideoHeightChange(TObject *Sender);
        void __fastcall edtASFVideoBitRateChange(TObject *Sender);
        void __fastcall edtASFVideoMaxKeyFrameSpacingChange(
          TObject *Sender);
        void __fastcall edtASFVideoQualityChange(TObject *Sender);
        void __fastcall edtASFAudioChannelsChange(TObject *Sender);
        void __fastcall VideoGrabberReencodingStarted(TObject *Sender,
          AnsiString SourceFile, AnsiString DestFile);
        void __fastcall VideoGrabberReencodingCompleted(TObject *Sender,
          AnsiString SourceFile, AnsiString DestFile, bool Success);
        void __fastcall btnViewDirectNetworkStreamingClick(
          TObject *Sender);
        void __fastcall VideoGrabberInactive(TObject *Sender);
        void __fastcall btnSourceVideoClipClick(TObject *Sender);
        void __fastcall btnStartReencodingClick(TObject *Sender);
        void __fastcall btnStartRecordingImmediatelyClick(TObject *Sender);
        void __fastcall btnStartRecordingControlledClick(TObject *Sender);
        void __fastcall VideoGrabberRecordingReadyToStart(TObject *Sender);
        void __fastcall chkRefreshPausedDisplayClick(TObject *Sender);
        void __fastcall VideoGrabberPlayerOpened(TObject *Sender);
        void __fastcall btnStopReencodingClick(TObject *Sender);
        void __fastcall chkPreserveNativeFormatClick(TObject *Sender);
        void __fastcall rdgDVPlaybackSizeClick(TObject *Sender);
        void __fastcall VideoGrabberDirectNetworkStreamingHostUrl(
          TObject *Sender, AnsiString HostUrl, AnsiString HostName,
          int HostPort);
        void __fastcall chkSetLogoClick(TObject *Sender);
        void __fastcall btnDurationClick(TObject *Sender);
        void __fastcall btnOpenLastClipRecordedClick(TObject *Sender);
        void __fastcall btnOpenLastClipPlayedClick(TObject *Sender);
        void __fastcall chkASFFixedFrameRateClick(TObject *Sender);
        void __fastcall cmbASFDeinterlaceModeChange(TObject *Sender);
        void __fastcall chkCroppingEnabledClick(TObject *Sender);
        void __fastcall chkCroppingOutboundsClick(TObject *Sender);
        void __fastcall edtCroppingWidthChange(TObject *Sender);
        void __fastcall edtCroppingHeightChange(TObject *Sender);
        void __fastcall trkCroppingZoomChange(TObject *Sender);
        void __fastcall btnCroppingZoomResetClick(TObject *Sender);
        void __fastcall trkCroppingYChange(TObject *Sender);
        void __fastcall trkCroppingXChange(TObject *Sender);
        void __fastcall cboVideoSourceChange(TObject *Sender);
        void __fastcall chkScreenRecordingWithCursorClick(TObject *Sender);
        void __fastcall tbrVMR9BrightnessChange(TObject *Sender);
        void __fastcall tbrVMR9ContrastChange(TObject *Sender);
        void __fastcall tbrVMR9SaturationChange(TObject *Sender);
        void __fastcall tbrVMR9HueChange(TObject *Sender);
        void __fastcall VideoGrabberGraphBuilt(TObject *Sender);
        void __fastcall vmr9FixRangeClick(TObject *Sender);
        void __fastcall chkChangeCursorClick(TObject *Sender);
        void __fastcall FormDestroy(TObject *Sender);
        void __fastcall chkAudioRecordingClick(TObject *Sender);
        void __fastcall tbrAudioVolumeChange(TObject *Sender);
        void __fastcall tbrAudioBalanceChange(TObject *Sender);
        void __fastcall chkMuteAudioRenderingClick(TObject *Sender);
        void __fastcall btnRenewRecordingFileClick(TObject *Sender);
        void __fastcall VideoGrabberRecordingStarted(TObject *Sender,
          AnsiString FileName);
        void __fastcall VideoGrabberCopyPreallocDataProgress(
          TObject *Sender, int Percent, Int64 Position, Int64 Duration);
        void __fastcall VideoGrabberRecordingCompleted(TObject *Sender,
          AnsiString FileName, bool Success);
        void __fastcall VideoGrabberReencodingProgress(TObject *Sender,
          int Percent, Int64 Position, Int64 Duration);
        void __fastcall VideoGrabberCreatePreallocFileProgress(
          TObject *Sender, int Percent, Int64 Position, Int64 Duration);
        void __fastcall VideoGrabberTVChannelSelected(TObject *Sender,
          int Channel, bool Locked, int DefaultVideoFrequency,
          int OverriddenVideoFrequency, int TunerVideoFrequency,
          int TunerAudioFrequency);
        void __fastcall btnOpenFileOrUrlClick(TObject *Sender);
        void __fastcall edtVideoSourceFileOrUrlChange(TObject *Sender);
        void __fastcall VideoGrabberFrameOverlayUsingDC(TObject *Sender,
          HDC Dc, DWORD FrameNumber, Int64 FrameTime, int FrameId);
        void __fastcall VideoGrabberFrameOverlayUsingDIB(TObject *Sender,
          HBITMAP FrameBitmapHandle, DWORD FrameNumber, Int64 FrameTime,
          int FrameId);
        void __fastcall VideoGrabberFrameOverlayUsingVIDEOHDR(
          TObject *Sender, DWORD FrameNumber, Int64 FrameTime, int FrameId,
          const TVideoHdr &VideoHdr);
        void __fastcall VideoGrabberFrameProgress(TObject *Sender,
          DWORD FrameNumber, Int64 FrameTime, int FrameId);
        void __fastcall VideoGrabberVideoFromBitmapsFormatNeeded(
          TObject *Sender, HBITMAP BitmapHandle, AnsiString BMPorJPEGFile);
        void __fastcall VideoGrabberVideoFromBitmapsNextFrameNeeded(
          TObject *Sender, bool FirstSample, HBITMAP BitmapHandle,
          AnsiString BMPorJPEGFile, bool EndOfData);
        void __fastcall btnNativeFormatClick(TObject *Sender);
        void __fastcall btnLoadImageOverlayFromFileClick(TObject *Sender);
        void __fastcall VideoGrabberFrameCaptureCompleted(TObject *Sender,
          Pointer FrameBitmap, int BitmapWidth, int BitmapHeight,
          DWORD FrameNumber, Int64 FrameTime, TFrameCaptureDest DestType,
          AnsiString FileName, bool Success, int FrameId);
        void __fastcall VideoGrabberMotionDetected(TObject *Sender,
          double GlobalMotionRatio, int MaxMotionCellX, int MaxMotionCellY,
          Pointer FrameBitmap, DWORD FrameNumber, Int64 FrameTime,
          int FrameId, bool &CaptureFrame);
        void __fastcall VideoGrabberMotionNotDetected(TObject *Sender,
          Pointer FrameBitmap, DWORD FrameNumber, Int64 FrameTime,
          int FrameId, bool &CaptureFrame);
        void __fastcall btnOpenClipClick(TObject *Sender);
        void __fastcall btnPlayerCloseClipClick(TObject *Sender);
        void __fastcall btnGetClipDurationClick(TObject *Sender);
        void __fastcall cmbBitmapOverlayTransparentColorChange(
          TObject *Sender);
        void __fastcall updBitmapOverlayAlphaBendClick(TObject *Sender,
          TUDBtnType Button);
        void __fastcall chkMultiplexedAutoSwitchClick(TObject *Sender);
        void __fastcall chkMultiplexedInputEmulationClick(TObject *Sender);
        void __fastcall btnTriggerNowClick(TObject *Sender);
        void __fastcall chkTriggeredClick(TObject *Sender);
private:	// User declarations
        int StartupWidth;
        int StartupHeight;

        TForm *SnapForm;
        TImage *SnapImage;
        TForm *TransparentForm;
        TPanel *TransparentPanel;
        int ThirdPartyFilterIndex;

        TRect FreeHandMouseDrawing[FreeHandMouseMax];
        int iFreeHandMouseDrawing;
        bool FreeHandMouseDrawingEnabled;

        TSearchRec SearchBmpFiles;
        bool SearchBmpFilesOpened;
        AnsiString SearchBmpPath;

        int cmbBitmapOverlayTransparentColorItemIndex; // intermediary variable used to read the ItemIndex from the OnFrameOverlayUsingDC event
        int updBitmapOverlayAlphaBendPosition;         // intermediary variable used to read the Position from the OnFrameOverlayUsingDC event

        void __fastcall RefreshDisplayOptions (void);
        void __fastcall RefreshVideoDeviceControls (void);
        void __fastcall ShowFormAboveVideo (TForm *Form);
        void __fastcall SendVCRCommand (TMenuItem *Sender);
public:		// User declarations
        __fastcall TfrmMainForm(TComponent* Owner);
        void __fastcall TfrmMainForm::InitVMR9Trackbar (TVMR9ImageAdjustment VMR9ImageAdjustment, TTrackBar *Trackbar);
};
//---------------------------------------------------------------------------
extern PACKAGE TfrmMainForm *frmMainForm;
//---------------------------------------------------------------------------
#endif
