//---------------------------------------------------------------------------
#ifndef VideoFromBMPorJPEGfiles_H
#define VideoFromBMPorJPEGfiles_H
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "VidGrab.hpp"
#include <ExtCtrls.hpp>
//---------------------------------------------------------------------------

// TFileSearch: small class around FindFirst and FindNext to make the search easier
class TFileSearch : public TComponent
{
private:
      bool Opened;
      AnsiString Path;
      TSearchRec SearchRec;
public:
      __fastcall TFileSearch(TComponent* Owner);
      __fastcall ~TFileSearch();
      AnsiString __fastcall FirstFile (AnsiString SearchPath, AnsiString FileKind);
      AnsiString __fastcall NextFile ();
      void __fastcall Close ();
};

class TForm1 : public TForm
{
__published:	// IDE-managed Components
        TVideoGrabber *VideoGrabber;
        TButton *btnStartPreview;
        TEdit *edtFilesLocation;
        TButton *btnStartRecording;
        TButton *btnStop;
        TMemo *mmoLog;
        TButton *btnPlay;
        TEdit *edtFrameProgress;
        TLabel *Label1;
        TRadioGroup *rdgSearchForBMPorJPEG;
        TEdit *edtFrameRate;
        TLabel *Label2;
        void __fastcall VideoGrabberLog(TObject *Sender, TLogType LogType,
          AnsiString Severity, AnsiString InfoMsg);
        void __fastcall FormCreate(TObject *Sender);
        void __fastcall VideoGrabberFrameProgress(TObject *Sender,
          DWORD FrameNumber, Int64 FrameTime, int FrameId);
        void __fastcall VideoGrabberVideoFromBitmapsFormatNeeded(
          TObject *Sender, HBITMAP &BitmapHandle,
          AnsiString &BMPorJPEGFile);
        void __fastcall VideoGrabberVideoFromBitmapsNextFrameNeeded(
          TObject *Sender, bool FirstSample, HBITMAP &BitmapHandle,
          AnsiString &BMPorJPEGFile, bool &EndOfData);
        void __fastcall btnStartPreviewClick(TObject *Sender);
        void __fastcall btnStartRecordingClick(TObject *Sender);
        void __fastcall btnStopClick(TObject *Sender);
        void __fastcall btnPlayClick(TObject *Sender);
private:	// User declarations
        TFileSearch *SearchForFiles;
        bool __fastcall GetNextBitmap (AnsiString &BMPorJPEGfile);
public:		// User declarations
        __fastcall TForm1(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TForm1 *Form1;
//---------------------------------------------------------------------------
#endif
